<?php
//set the Gargoyle router configuration here
$router = 'http://192.168.0.1'; //Location of the Router webinterface
$pass = 'password'; //Router login password

//this function grabs a file from the router using the PHP CURL library, pass the desired filename as parameter
function GrabFile($file) {
global $router,$pass;
$data="password=$pass"; 

$ch = curl_init(); 
//first use CURL to get the login cookie
curl_setopt($ch, CURLOPT_URL, $router."/utility/get_password_cookie.sh");
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11"); 
curl_setopt($ch, CURLOPT_POST, 1); 
curl_setopt($ch, CURLOPT_POSTFIELDS, $data); 
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); 
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
curl_setopt($ch, CURLOPT_HEADER, 1);
$header = curl_exec ($ch);

//extract cookie string from header. Cookie starts at first "Set-Cookie" ocurrence
$p = strpos($header,'Set-Cookie');
//copy string from "Set-Cookie" to end of string
$cookie=substr($header,$p+11,strlen($header)); 
//remove unwanted stuff from cookie
$cookie = str_replace('Set-Cookie:','',$cookie); 
$cookie = str_replace('Path=/;',' ',$cookie); 
$cookie = str_replace(';','',$cookie); 
$cookie = str_replace(' ','',$cookie); 

//get the cookie information (hash and exp)
$hashStart = strpos($cookie,'hash=');
$expireDateStart = strpos($cookie,'exp=');
$hash = substr($cookie,$hashStart,$expireDateStart-$hashStart-1);
$expire = substr($cookie,$expireDateStart,strlen($cookie));

//join the cookie information in a valid cookie string for CURLOPT_COOKIE parameter.
$cookie = $hash.'; '.$expire;

//Grab the requested file from the router
curl_setopt($ch, CURLOPT_URL, $router."/".$file);
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11"); 
curl_setopt($ch, CURLOPT_POST, false); 
curl_setopt($ch, CURLOPT_COOKIE, $cookie);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); 
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 0); 
$html = curl_exec($ch);
curl_close($ch);

//verify if the resulting html is valid by checking if some part of the html in the login form exists. 
if (strpos($html, "id='password_label'") === FALSE) { 
	  //login OK, the output should be the CSV so lets convert the output to an array (each line of the CSV is one element)
	  $html=nl2br($html);
	  $lines = explode('<br />',$html);
	  //return the array of lines
      return $lines; 
    } else { 
	  //login form found means the login process didnt work, lets return FALSE.
      return false; 
    } 
}

//get CSV files from Gargoyle router
$visitedSitesCSV = GrabFile('webmon_domains.csv');
$searchRequestsCSV = GrabFile('webmon_searches.csv');
if ($visitedSitesCSV === FALSE) { 
echo 'Unable to retrieve visited sites!';
} else
{
print_r($visitedSitesCSV);
}

if ($searchRequestsCSV === FALSE) { 
echo 'Unable to retrieve search requests!';
} else
{
print_r($searchRequestsCSV);
}

?>

